#include <avr/io.h>

#define myclear() { PORTB &= ~( 1 << PB6 ); }
#define myset() { PORTB |= 1 << PB6; }
#define mytoggle() { PORTB ^= 1 << PB6; }

#define mylongwait() { uint16_t c1, c2; c1=TCNT1; do { c2 = TCNT1;} while((c2-c1)<2000);}
#define mywait() { uint16_t c1, c2; c1=TCNT1; do { c2 = TCNT1;} while((c2-c1)<400);}
#define myshortwait() { uint16_t c1, c2; c1=TCNT1; do { c2 = TCNT1;} while((c2-c1)<3);}

#define myinput() ( ( PINB ) & ( 1 << PINB5 ) )

static inline void send1Bit()
{
    while ( myinput() == 0 );
    myshortwait();
    mytoggle();
    while ( myinput() != 0 );
    myshortwait();
    mytoggle();
}

static inline void send0Bit()
{
    while ( myinput() == 0 );
    myshortwait();
    mytoggle();
    while ( myinput() != 0 );
    myshortwait();
}

void sendValue( uint16_t v )
{
    uint8_t t = 16;

    v++;

    send1Bit();
    
    for ( t = 0; t < 16; t++ ) {
        send0Bit();
    }
    send1Bit();

    send1Bit();
    
    for ( t = 0; t < 16; t++ ) {
        if ( v & 1 ) {
            send1Bit();
        } else {
            send0Bit();
        }
        v >>= 1;
    }
    send1Bit();
}

uint8_t key_values[70];

int main( void )
{
    uint8_t v_old, v;
    uint16_t c;
    uint8_t values_pos = 0;

    DDRB |= 1 << DDB6;
    DDRD = 0;
    myclear();

    // set timer1 counter to freq/256
    TCCR1B = ( TCCR1B & ( ~7 ) ) | ( 1 << 2 );

    // reset prescaler
    GTCCR |= 1;

    sendValue( 12345 );

    v_old = ( PIND ) & ( 1 << PIND2 );
    while ( 1 ) {
        do {
            v = ( PIND ) & ( 1 << PIND2 );
        } while ( v == v_old );
        c = TCNT1;

        // reset counter
        TCNT1 = 0;
        
        if ( c > 3 ) {
            if ( c < 256 ) {
                if ( values_pos >= ( sizeof( key_values ) / sizeof( key_values[0] ) ) ) {
                } else {
                    key_values[values_pos++] = c & 0xff;
                }
            } else {
                for ( c = 0; c < values_pos; c++ ) {
                    sendValue( key_values[c] );
                }
                values_pos = 0;
            }
        }

        v_old = v;
    }

    return 0;
}
